'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EchartsOnReact = function (_React$Component) {
  _inherits(EchartsOnReact, _React$Component);

  function EchartsOnReact(props) {
    _classCallCheck(this, EchartsOnReact);

    var _this = _possibleConstructorReturn(this, (EchartsOnReact.__proto__ || Object.getPrototypeOf(EchartsOnReact)).call(this, props));

    _this.echarts = _this.props.echarts;
    _this.getRef = _this.getRef.bind(_this);
    return _this;
  }

  _createClass(EchartsOnReact, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          options = _props.options,
          notMerge = _props.notMerge,
          lazyUpdate = _props.lazyUpdate,
          silent = _props.silent;

      this.chart = this.echarts.init(this.chartRef);
      this.chart.setOption(options, { notMerge: notMerge, lazyUpdate: lazyUpdate, silent: silent });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      var updateData = props.updateData;

      var series = updateData.map(function (data) {
        return { data: data };
      });
      this.chart.setOption({ series: series });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _reactDom2.default.unmountComponentAtNode(this.chartRef);
    }
  }, {
    key: 'getRef',
    value: function getRef(ref) {
      this.chartRef = ref;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          style = _props2.style,
          className = _props2.className;

      return _react2.default.createElement('div', {
        ref: this.getRef,
        style: Object.assign({ width: '100%', height: '100%' }, style),
        className: className });
    }
  }]);

  return EchartsOnReact;
}(_react2.default.Component);

exports.default = EchartsOnReact;